//
//			32 word x 16 bit Adjustable-length Shift register
//
//					(C) Copyright 2004 John B. Stephensen
//
// This Verilog source file and all its derivatives are licensed only for
// personal non-profit educational use in the Amateur Radio Service and
// the license is not transferrable. The information is provided as-is for
// experimental purposes and the author does not warranty its freedom
// from defects or its suitability for any specific application.
//
//	16 slices.
//
module srl32x16e(y,d,a,ce,clk);
    output [15:0] y;	// output selected by address
    input [15:0] d;	// input	word
	 input [4:0] a;	// address of output word
    input ce;			// enable input
    input clk;			// clock input
// 16 32-bit shift registers
SRL32E sr0 (.D(d[0]), .A0(a[0]), .A1(a[1]), .A2(a[2]), .A3(a[3]), .A4(a[4]), .CLK(clk), .CE(ce), .Q(y[0]));
SRL32E sr1 (.D(d[1]), .A0(a[0]), .A1(a[1]), .A2(a[2]), .A3(a[3]), .A4(a[4]), .CLK(clk), .CE(ce), .Q(y[1]));
SRL32E sr2 (.D(d[2]), .A0(a[0]), .A1(a[1]), .A2(a[2]), .A3(a[3]), .A4(a[4]), .CLK(clk), .CE(ce), .Q(y[2]));
SRL32E sr3 (.D(d[3]), .A0(a[0]), .A1(a[1]), .A2(a[2]), .A3(a[3]), .A4(a[4]), .CLK(clk), .CE(ce), .Q(y[3]));
SRL32E sr4 (.D(d[4]), .A0(a[0]), .A1(a[1]), .A2(a[2]), .A3(a[3]), .A4(a[4]), .CLK(clk), .CE(ce), .Q(y[4]));
SRL32E sr5 (.D(d[5]), .A0(a[0]), .A1(a[1]), .A2(a[2]), .A3(a[3]), .A4(a[4]), .CLK(clk), .CE(ce), .Q(y[5]));
SRL32E sr6 (.D(d[6]), .A0(a[0]), .A1(a[1]), .A2(a[2]), .A3(a[3]), .A4(a[4]), .CLK(clk), .CE(ce), .Q(y[6]));
SRL32E sr7 (.D(d[7]), .A0(a[0]), .A1(a[1]), .A2(a[2]), .A3(a[3]), .A4(a[4]), .CLK(clk), .CE(ce), .Q(y[7]));
SRL32E sr8 (.D(d[8]), .A0(a[0]), .A1(a[1]), .A2(a[2]), .A3(a[3]), .A4(a[4]), .CLK(clk), .CE(ce), .Q(y[8]));
SRL32E sr9 (.D(d[9]), .A0(a[0]), .A1(a[1]), .A2(a[2]), .A3(a[3]), .A4(a[4]), .CLK(clk), .CE(ce), .Q(y[9]));
SRL32E sr10 (.D(d[10]), .A0(a[0]), .A1(a[1]), .A2(a[2]), .A3(a[3]), .A4(a[4]), .CLK(clk), .CE(ce), .Q(y[10]));
SRL32E sr11 (.D(d[11]), .A0(a[0]), .A1(a[1]), .A2(a[2]), .A3(a[3]), .A4(a[4]), .CLK(clk), .CE(ce), .Q(y[11]));
SRL32E sr12 (.D(d[12]), .A0(a[0]), .A1(a[1]), .A2(a[2]), .A3(a[3]), .A4(a[4]), .CLK(clk), .CE(ce), .Q(y[12]));
SRL32E sr13 (.D(d[13]), .A0(a[0]), .A1(a[1]), .A2(a[2]), .A3(a[3]), .A4(a[4]), .CLK(clk), .CE(ce), .Q(y[13]));
SRL32E sr14 (.D(d[14]), .A0(a[0]), .A1(a[1]), .A2(a[2]), .A3(a[3]), .A4(a[4]), .CLK(clk), .CE(ce), .Q(y[14]));
SRL32E sr15 (.D(d[15]), .A0(a[0]), .A1(a[1]), .A2(a[2]), .A3(a[3]), .A4(a[4]), .CLK(clk), .CE(ce), .Q(y[15]));
endmodule
